#
# Conditional build:
%bcond_without	spirv_opt	# spirv-opt capability
%bcond_without	tests		# testing

Summary:	Khronos reference front-end for GLSL and ESSL
Summary(pl.UTF-8):	Wzorcowy frontend GLSL i ESSL z projektu Khronos
Name:		glslang
Version:	15.1.0
Release:	1
License:	BSD-like
Group:		Applications/Graphics
#Source0Download: https://github.com/KhronosGroup/glslang/releases
Source0:	https://github.com/KhronosGroup/glslang/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	2bf049666f223732fc18d6c8b16b98cf
Patch0:		%{name}-symlink.patch
URL:		https://github.com/KhronosGroup/glslang
BuildRequires:	bison
BuildRequires:	cmake >= 3.27
BuildRequires:	libstdc++-devel >= 6:7
BuildRequires:	python3
BuildRequires:	python3-modules
BuildRequires:	rpmbuild(macros) >= 1.605
%if %{with tests} || %{with spirv_opt}
BuildRequires:	spirv-tools-devel >= 1:2025.1
%endif
%if %{with spirv_opt}
%requires_ge_to	spirv-tools-libs spirv-tools-devel
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
An OpenGL and OpenGL ES shader front end and validator.

%description -l pl.UTF-8
Frontend i walidator shaderów OpenGL i OpenGL ES.

%package devel
Summary:	Khronos reference front-end libraries for GLSL and ESSL
Summary(pl.UTF-8):	Wzorcowe biblioteki frontendowe GLSL i ESSL z projektu Khronos
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
A front-end libraries for programmatic parsing of GLSL/ESSL into an
AST.

%description devel -l pl.UTF-8
Biblioteki frontendowe do programowej analizy GLSL/ESSL do postaci
AST.

%prep
%setup -q
%patch -P0 -p1

%build
%cmake -B build \
	-DALLOW_EXTERNAL_SPIRV_TOOLS=ON \
	%{!?with_spirv_opt:-DENABLE_OPT=OFF}

%{__make} -C build

%if %{with tests}
cd Test
LD_LIBRARY_PATH=../build/StandAlone
./runtests localResults ../build/StandAlone/glslangValidator ../build/StandAlone/spirv-remap
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGES.md LICENSE.txt README-spirv-remap.txt
%attr(755,root,root) %{_bindir}/glslang
%attr(755,root,root) %{_bindir}/glslangValidator
%attr(755,root,root) %{_bindir}/spirv-remap
%attr(755,root,root) %{_libdir}/libSPIRV.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libSPIRV.so.15
%attr(755,root,root) %{_libdir}/libSPVRemapper.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libSPVRemapper.so.15
%attr(755,root,root) %{_libdir}/libglslang.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libglslang.so.15
%attr(755,root,root) %{_libdir}/libglslang-default-resource-limits.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libglslang-default-resource-limits.so.15

%files devel
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_libdir}/libSPIRV.so
%attr(755,root,root) %{_libdir}/libSPVRemapper.so
%attr(755,root,root) %{_libdir}/libglslang.so
%attr(755,root,root) %{_libdir}/libglslang-default-resource-limits.so
%{_includedir}/glslang
%{_libdir}/cmake/glslang
%changelog
* Sun Mar 23 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/glslang.git;a=log;h=master

* Sun Mar 23 2025 Jakub Bogusz <qboosh@pld-linux.org> 4f879f6
- updated to 15.1.0 with Vulkan 1.4 support

* Sun Mar 23 2025 Jakub Bogusz <qboosh@pld-linux.org> 1fd7605
- use patch -P

* Sun May 26 2024 Jakub Bogusz <qboosh@pld-linux.org> 34a7159
- updated to 14.1.0

* Thu Feb 29 2024 Jakub Bogusz <qboosh@pld-linux.org> 67e4c0e
- added symlink patch (fix glslangValidator compatibility symlink creation; still required by Mesa)

* Sun Feb 18 2024 Jakub Bogusz <qboosh@pld-linux.org> 9add083
- updated to 14.0.0 (new sonames, HLSL stub library dropped)

* Wed Sep 27 2023 Jan Palus <atler@pld-linux.org> 1fbca11
- macros for %cmake

* Wed Sep 27 2023 Jan Palus <atler@pld-linux.org> 64275ec
- BR: python3 python3-modules for gen_extension_headers.py

* Tue Sep 26 2023 Jakub Bogusz <qboosh@pld-linux.org> 3786140
- updated to 12.3.1; patched to fix symlinking with DESTDIR and absolute CMAKE_INSTALL_BINDIR

* Tue Apr 04 2023 Jakub Bogusz <qboosh@pld-linux.org> a827034
- updated to 12.1.0 (new sonames)

* Mon Dec 27 2021 Jakub Bogusz <qboosh@pld-linux.org> d1c92ae
- updated to 11.7.1 (tagged also as sdk-1.2.198.0)

* Wed Apr 28 2021 Jakub Bogusz <qboosh@pld-linux.org> 412b65f
- rediffed

* Wed Apr 28 2021 Jakub Bogusz <qboosh@pld-linux.org> 634c8c7
- run ldconfig

* Wed Apr 28 2021 Jakub Bogusz <qboosh@pld-linux.org> b70087f
- updated to 11.1.0 (last version that builds with spirv-tools 2020.6; new libglslang soname)

* Sun Jul 05 2020 Jakub Bogusz <qboosh@pld-linux.org> eeb9265
- updated to 8.13.3743
- removed obsolete vulkan1.2 patch

* Sun Mar 15 2020 Jakub Bogusz <qboosh@pld-linux.org> fd4cb22
- updated to 8.13.3559
- removed outdated runtests patch, just use new runtests arguments
- added vulkan1.2 patch (Vulkan 1.2 support, required for shaderc 2019.1)

* Sat Jan 18 2020 Jan Palus <atler@pld-linux.org> b091f92
- release 2 (by relup.sh)

* Sat Jan 18 2020 Jan Palus <atler@pld-linux.org> 7519683
- add spirv_opt bcond; add versioned runtime dep on spirv-tools-libs

* Sat Sep 21 2019 Jakub Bogusz <qboosh@pld-linux.org> 6a12360
- Merge remote-tracking branch 'origin/SPIRV-1.3'

* Sat Sep 21 2019 Jan Palus <atler@pld-linux.org> bf8c063
- up to 7.12.3352

* Fri May 31 2019 Jakub Bogusz <qboosh@pld-linux.org> 3849af3
- -devel requires base, few libraries are shared now

